if (!variable_global_exists("gg2i_using_clientside")) {
//Draw Hat!
object_event_add(Character, ev_draw, 0, "
	xoffset = view_xview[0];
	yoffset = view_yview[0];
	
	var xr, yr;
	xr = round(x);
	yr = round(y);

	image_alpha = cloakAlpha;

	if (global.myself.team == team and canCloak)
		image_alpha = cloakAlpha/2 + 0.5;

	if (invisible)
		exit;

	if(stabbing)
		image_alpha -= power(currentWeapon.stab.alpha, 2);
	
	draw_set_alpha(1);
	
	var ubercolour;
	if (player.team == TEAM_RED)
		ubercolour = c_red;
	else
		ubercolour = c_blue;
	
	var noNewAnim, overlayList;
	var gg2i_tilt_left_head, gg2i_tilt_left_torso, gg2i_tilt_left_leg, gg2i_tilt_right_head, gg2i_tilt_right_torso, gg2i_tilt_right_leg;
	var overlays_tilt_left, overlays_tilt_right;
	noNewAnim = (player.class == CLASS_QUOTE or sprite_special or player.humiliated);
	overlayOffset = 0;
	
	var gg2i_sprite_head, gg2i_sprite_torso, gg2i_sprite_leg;
	
	if (!omnomnomnom && !taunting && !player.humiliated)
	{
		if (zoomed)
		{
			if (player.gg2i_current_head_crouch != -1)
				gg2i_sprite_head = player.gg2i_current_head_crouch;
			else
				gg2i_sprite_head = gg2i_sniper_crouch[0];
			if (player.gg2i_current_torso_crouch != -1)
				gg2i_sprite_torso = player.gg2i_current_torso_crouch;
			else
				gg2i_sprite_torso = gg2i_sniper_crouch[1];
			if (player.gg2i_current_leg_crouch != -1)
				gg2i_sprite_leg = player.gg2i_current_leg_crouch;
			else
				gg2i_sprite_leg = gg2i_sniper_crouch[2];
			overlayList = crouchOverlays;
			animationImage = animationImage mod 2;
			
			if (player.team == TEAM_RED)
				animationOffset = 0;
			else
				animationOffset = 4;
		}
		else if (!noNewAnim)
		{
			if (!onground)
			{
				if (player.gg2i_current_head_jump != -1)
					gg2i_sprite_head = player.gg2i_current_head_jump;
				else
					gg2i_sprite_head = gg2i_head_jump[player.class];
				if (player.gg2i_current_torso_jump != -1)
					gg2i_sprite_torso = player.gg2i_current_torso_jump;			
				else
					gg2i_sprite_torso = gg2i_torso_jump[player.class];
				if (player.gg2i_current_leg_jump != -1)
					gg2i_sprite_leg = player.gg2i_current_leg_jump;				
				else
					gg2i_sprite_leg = gg2i_leg_jump[player.class];
				overlayList = jumpOverlays;
				animationImage = 0;
				if (player.team == TEAM_RED)
					animationOffset = 0;
				else
					animationOffset = 1;
			}
			else
			{
				if (still)
				{
					charSetSolids();
					if (image_xscale > 0)
					{
						if (player.gg2i_current_head_run != -1)
							gg2i_tilt_right_head = player.gg2i_current_head_run;
						else
							gg2i_tilt_right_head = gg2i_head_run[player.class];
						if (player.gg2i_current_head_run != -1)
							gg2i_tilt_left_head = player.gg2i_current_head_run;
						else
							gg2i_tilt_left_head = gg2i_head_run[player.class];
						if (player.gg2i_current_torso_run != -1)
							gg2i_tilt_right_torso = player.gg2i_current_torso_run;
						else
							gg2i_tilt_right_torso = gg2i_torso_run[player.class];
						if (player.gg2i_current_torso_run != -1)
							gg2i_tilt_left_torso = player.gg2i_current_torso_run;
						else
							gg2i_tilt_left_torso = gg2i_torso_run[player.class];
						if (player.gg2i_current_leg_run != -1)
							gg2i_tilt_right_leg = player.gg2i_current_leg_run;
						else
							gg2i_tilt_right_leg = gg2i_leg_leanl[player.class];
						if (player.gg2i_current_leg_run != -1)
							gg2i_tilt_left_leg = player.gg2i_current_leg_run;
						else
							gg2i_tilt_left_leg = gg2i_leg_run[player.class];
						overlays_tilt_left = leanLOverlays;
						overlays_tilt_right = leanROverlays;
					}
					else
					{
						if (player.gg2i_current_head_run != -1)
							gg2i_tilt_right_head = player.gg2i_current_head_run;
						else
							gg2i_tilt_right_head = gg2i_head_run[player.class];
						if (player.gg2i_current_head_run != -1)
							gg2i_tilt_left_head = player.gg2i_current_head_run;
						else
							gg2i_tilt_left_head = gg2i_head_run[player.class];
						if (player.gg2i_current_torso_run != -1)
							gg2i_tilt_right_torso = player.gg2i_current_torso_run;
						else
							gg2i_tilt_right_torso = gg2i_torso_run[player.class];
						if (player.gg2i_current_torso_run != -1)
							gg2i_tilt_left_torso = player.gg2i_current_torso_run;
						else
							gg2i_tilt_left_torso = gg2i_torso_run[player.class];
						if (player.gg2i_current_leg_run != -1)
							gg2i_tilt_right_leg = player.gg2i_current_leg_run;
						else
							gg2i_tilt_right_leg = gg2i_leg_leanl[player.class];
						if (player.gg2i_current_leg_run != -1)
							gg2i_tilt_left_leg = player.gg2i_current_leg_run;
						else
							gg2i_tilt_left_leg = gg2i_leg_run[player.class];
						overlays_tilt_left = leanROverlays;
						overlays_tilt_right = leanLOverlays;
					}
					
					overlayList = stillOverlays;
					if (player.team == TEAM_RED)
						animationOffset = 0;
					else
						animationOffset = 4;
					if (player.gg2i_current_head_run != -1)
						gg2i_sprite_head = player.gg2i_current_head_run;
					else
						gg2i_sprite_head = gg2i_head_run[player.class];
					if (player.gg2i_current_torso_run != -1)
						gg2i_sprite_torso = player.gg2i_current_torso_run;
					else
						gg2i_sprite_torso = gg2i_torso_run[player.class];
					if (player.gg2i_current_leg_run != -1)
						gg2i_sprite_leg = player.gg2i_current_leg_run;
					else
						gg2i_sprite_leg = gg2i_leg_run[player.class];
					overlayList = runOverlays;
					
					openright = !collision_point_solid(x+6, bbox_bottom+2) and !collision_point_solid(x+2, bbox_bottom+2);
					openleft = !collision_point_solid(x-7, bbox_bottom+2) and !collision_point_solid(x-3, bbox_bottom+2);
					if (openright)
					{
						gg2i_sprite_head = gg2i_tilt_right_head;
						gg2i_sprite_torso = gg2i_tilt_right_torso;
						gg2i_sprite_leg = gg2i_tilt_right_leg;
						overlayList = overlays_tilt_right;
					}
					if (openleft)
					{
						gg2i_sprite_head = gg2i_tilt_left_head;
						gg2i_sprite_torso = gg2i_tilt_left_torso;
						gg2i_sprite_leg = gg2i_tilt_left_leg;
						overlayList = overlays_tilt_left;
					}
					if (openright and openleft)
					{
						openright = !collision_point_solid(bbox_right, bbox_bottom+2);
						openleft = !collision_point_solid(bbox_left, bbox_bottom+2);
						if (openright)
						{
							gg2i_sprite_head = gg2i_tilt_right_head;
							gg2i_sprite_torso = gg2i_tilt_right_torso;
							gg2i_sprite_leg = gg2i_tilt_right_leg;
							overlayList = overlays_tilt_right;
						}
						if (openleft)
						{
							gg2i_sprite_head = gg2i_tilt_left_head;
							gg2i_sprite_torso = gg2i_tilt_left_torso;
							gg2i_sprite_leg = gg2i_tilt_left_leg;
							overlayList = overlays_tilt_left;
						}
					}
					charUnsetSolids();
				}
				else
				{
					if (player.gg2i_current_head_run != -1)
						gg2i_sprite_head = player.gg2i_current_head_run;
					else
						gg2i_sprite_head = gg2i_head_run[player.class];
					if (player.gg2i_current_torso_run != -1)
						gg2i_sprite_torso = player.gg2i_current_torso_run;
					else
						gg2i_sprite_torso = gg2i_torso_run[player.class];
					if (player.gg2i_current_leg_run != -1)
						gg2i_sprite_leg = player.gg2i_current_leg_run;
					else
						gg2i_sprite_leg = gg2i_leg_run[player.class];
					overlayList = runOverlays;
					if (player.team == TEAM_RED)
						animationOffset = 0;
					else
						animationOffset = 4;
				}
			}
		}
		else
		{
			if (player.class != 9)
			{
				overlayList = stillOverlays;
				if (player.gg2i_current_head_stand != -1)
					gg2i_sprite_head = player.gg2i_current_head_stand;
				else
					gg2i_sprite_head = gg2i_head_stand[player.class];
				if (player.gg2i_current_torso_stand != -1)
					gg2i_sprite_torso = player.gg2i_current_torso_stand;
				else
					gg2i_sprite_torso = gg2i_torso_stand[player.class];
				if (player.gg2i_current_leg_stand != -1)
					gg2i_sprite_leg = player.gg2i_current_leg_stand;
				else
					gg2i_sprite_leg = gg2i_leg_stand[player.class];
				if (player.team == TEAM_RED)
					animationOffset = 0;
				else
					animationOffset = 1;
			}
			else
			{
				overlayList = stillOverlays;
				if (team == TEAM_RED)
					animationOffset = 0;
				else
					animationOffset = 4;
				if (intel)
					animationOffset += 2;
				if (player.gg2i_current_quote_head != -1)
					gg2i_sprite_head = player.gg2i_current_quote_head;
				else
					gg2i_sprite_head = gg2i_quote_head;
				if (player.gg2i_current_quote_body != -1)
					gg2i_sprite_torso = player.gg2i_current_quote_body;
				else
					gg2i_sprite_torso = gg2i_quote_body;
				sprite_set_offset(gg2i_sprite_head, sprite_get_xoffset(QuerlyRedS), sprite_get_yoffset(QuerlyRedS));
				sprite_set_offset(gg2i_sprite_torso, sprite_get_xoffset(QuerlyRedS), sprite_get_yoffset(QuerlyRedS));
			}
		}
		if (overlayList != stillOverlays and (overlayList == leanLOverlays or overlayList == leanROverlays)
			and !stabbing and !noNewAnim)
			yoffset = 6;
		else
			yoffset = 0;
		equipmentOffset = ((overlayList == runOverlays) and (floor(animationImage) mod 2) == 0) and onground;
		equipmentOffset *= -2;
		
		overlayOffset = equipmentOffset;
		
		if ((player.class == CLASS_HEAVY) and abs(hspeed) < 3) or (player.class == CLASS_SOLDIER) or noNewAnim or taunting
		{
			equipmentOffset = 0;
			overlayOffset = 0;
		}
		else if (abs(hspeed) < 3 and equipmentOffset = -2 and !taunting)
		{
			equipmentOffset += 2;
			yr += 2;
			overlayOffset = equipmentOffset - 2;
		}
		else
			overlayOffset = equipmentOffset;
		
		equipmentOffset += yoffset;
		yr += yoffset;
		
		if (player.gg2i_unusual[player.class] != -1)
		{
			//Circling unusual(below character)
			if (player.gg2i_unusual[player.class] div 100 == 0 && unusual_yoffset < 0)
			{
				draw_sprite_ext(gg2i_unusual_circling_effect[player.gg2i_unusual[player.class]], floor(id / sprite_get_number(gg2i_unusual_circling_effect[player.gg2i_unusual[player.class]])), x + unusual_xoffset, yr - 13 + unusual_yoffset, 0.5, 0.5, 0, -1, image_alpha);
			}
			//Fixed
			else if (player.gg2i_unusual[player.class] div 100 == 1)
			{
				draw_sprite_ext(gg2i_unusual_fixed_effect[player.gg2i_unusual[player.class] - 100], floor(timer/3), x, yr - 18 , 1, 1, 0, -1, image_alpha);
			}
			else if (player.gg2i_unusual[player.class] div 100 == 2)
			{
				draw_sprite_ext(gg2i_unusual_above_effect[player.gg2i_unusual[player.class] - 200], floor(timer/3), x, yr - 50 , 1, 1, 0, -1, image_alpha);
			}
		}
		if (intel and player.class != CLASS_QUOTE and !zoomed)
			draw_sprite_ext(gg2i_intel[player.class], player.team, xr, round(y)+equipmentOffset, image_xscale, image_yscale, 0, c_white, image_alpha);
		if (player.class != 9)
		{
			sprite_set_offset(gg2i_sprite_head, sprite_get_xoffset(sprite_index), sprite_get_yoffset(sprite_index));
			sprite_set_offset(gg2i_sprite_torso, sprite_get_xoffset(sprite_index), sprite_get_yoffset(sprite_index));
			sprite_set_offset(gg2i_sprite_leg, sprite_get_xoffset(sprite_index), sprite_get_yoffset(sprite_index));
			if (sprite_get_number(gg2i_sprite_head) > 8)
			{
				if (player.team == TEAM_RED)
					animationOffset = player.class * sprite_get_number(gg2i_sprite_head)/9;
				else
					animationOffset = player.class * sprite_get_number(gg2i_sprite_head)/9 + sprite_get_number(gg2i_sprite_head)/18;
			}
			if(!ubered)
			{
				draw_sprite_ext_overlay(gg2i_sprite_head, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, c_white, image_alpha, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_leg, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, c_white, image_alpha, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_torso, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, c_white, image_alpha, overlayOffset);
			}
			else
			{
				draw_sprite_ext_overlay(gg2i_sprite_head, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, c_white, 1, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_head, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, ubercolour, 0.7, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_leg, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, c_white, 1, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_leg, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, ubercolour, 0.7, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_torso, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, c_white, 1, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_torso, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, ubercolour, 0.7, overlayOffset);
			}
		}
		else
		{
			if(!ubered)
			{
				draw_sprite_ext_overlay(gg2i_sprite_head, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, c_white, image_alpha, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_torso, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, c_white, image_alpha, overlayOffset);
			}
			else
			{
				draw_sprite_ext_overlay(gg2i_sprite_head, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, c_white, 1, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_head, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, ubercolour, 0.7, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_torso, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, c_white, 1, overlayOffset);
				draw_sprite_ext_overlay(gg2i_sprite_torso, overlayList, gearList, floor(animationImage + animationOffset), xr, yr, image_xscale, image_yscale, image_angle, ubercolour, 0.7, overlayOffset);
			}
		}
		
		//Draw unusual effect
		if (player.gg2i_unusual[player.class] != -1)
		{
			//Circling(above character)
			if (player.gg2i_unusual[player.class] div 100 == 0 && unusual_yoffset >= 0)
			{
				draw_sprite_ext(gg2i_unusual_circling_effect[player.gg2i_unusual[player.class]], floor(id / sprite_get_number(gg2i_unusual_circling_effect[player.gg2i_unusual[player.class]])), x + unusual_xoffset, yr - 13 + unusual_yoffset, 0.5, 0.5, 0, -1, image_alpha);
			}
		}
	}
");

//Modify unusual effect for circling type
object_event_add(Character, ev_step, ev_step_end, "
	unusual_xoffset = 15*sin(timer*180/(pi*400));
	unusual_yoffset = 7*cos(timer*180/(pi*400));
");

}