if (!variable_global_exists("gg2i_using_clientside")) {

	//Set Weapon
	object_event_add(Weapon, ev_step, ev_step_normal, "
		if (!variable_local_exists('_normalSprite'))
		{
			_normalSprite = normalSprite;
			if (ownerPlayer.gg2i_current_weapon != -1)
				sprite_index = ownerPlayer.gg2i_current_weapon;
		}
		if (!variable_local_exists('_recoilSprite'))
			_recoilSprite = recoilSprite;
		if (!variable_local_exists('_reloadSprite'))
			_reloadSprite = reloadSprite;
			
		if (ownerPlayer.gg2i_current_weapon != -1)
			normalSprite = ownerPlayer.gg2i_current_weapon;
		else
			normalSprite = _normalSprite;
		if (ownerPlayer.gg2i_current_weapon_fs != -1)
			recoilSprite = ownerPlayer.gg2i_current_weapon_fs;
		else
			recoilSprite = _recoilSprite;
		if (ownerPlayer.gg2i_current_weapon_frs != -1)
			reloadSprite = ownerPlayer.gg2i_current_weapon_frs;
		else
			reloadSprite = _reloadSprite;
	");

	//Exception for Medigun
	object_event_add(Medigun, ev_step, ev_step_normal, "
		event_inherited();
	");

	//Exception for Rifle
	object_event_add(Rifle, ev_step, ev_step_end, "
		recoilTime = 15/global.delta_factor;
		recoilAnimLength = sprite_get_number(recoilSprite)/2;
		recoilImageSpeed = recoilAnimLength/(recoilTime);

		longRecoilTime = 60/global.delta_factor;
		reloadAnimLength = sprite_get_number(reloadSprite)/2
		reloadImageSpeed = reloadAnimLength/(longRecoilTime);
	");

	//Exception for Flamethrower
	object_event_add(Flamethrower, ev_step, ev_step_normal, "
		event_inherited();
		if (ownerPlayer.gg2i_current_weapon_blast != -1)
			blastSprite = ownerPlayer.gg2i_current_weapon_blast;
		else
			blastSprite = FlamethrowerBlastS;
		if (ownerPlayer.gg2i_current_weapon_drop != -1)
			dropSprite = ownerPlayer.gg2i_current_weapon_drop;
		else
			dropSprite = FlamethrowerDropS;
	");

	//Making title & Strange weapon in DeathCam
	object_event_add(DeathCam, ev_alarm, 0, "
		gg2i_titlemessage = killedby.gg2i_title;
		gg2i_titlesprite = -1;
		if (gg2i_titlemessage != '')
			gg2i_titlesprite = sprite_add(gg2i.spriteDirectory + '/Titles/' + gg2i_titlemessage + '.png', 1, 1, 0, 0, 0);
		
		gg2i_strangeMessage[0] = '';
		gg2i_strangeMessage[1] = '';
		gg2i_strangeMessage[2] = '';
		gg2i_strangeType = '';
		gg2i_strangeCount = -1;
		if (killedby.object > 0)
		{
			if (killedby.gg2i_strange_type[killedby.class] > -1)
			{
				gg2i_strangeMessage[0] += killedby.name + ' is carrying';

				gg2i_strangeMessage[1] += ds_list_find_value(killedby.gg2i_weapon_list, killedby.class);
				gg2i_strangeMessage[1] = string_replace_all(gg2i_strangeMessage[1], '_', ' ');
				
				switch (killedby.gg2i_strange_type[killedby.class])
				{
					case 0:
						gg2i_strangeType = 'Kills'
						break;
					case 1:
						gg2i_strangeType = 'Runners Killed'
						break;
					case 2:
						gg2i_strangeType = 'Firebugs Killed'
						break;
					case 3:
						gg2i_strangeType = 'Rocketmans Killed'
						break;
					case 4:
						gg2i_strangeType = 'Overweights Killed'
						break;
					case 5:
						gg2i_strangeType = 'Detonators Killed'
						break;
					case 6:
						gg2i_strangeType = 'Healers Killed'
						break;
					case 7:
						gg2i_strangeType = 'Constructors Killed'
						break;
					case 8:
						gg2i_strangeType = 'Infiltrators Killed'
						break;
					case 9:
						gg2i_strangeType = 'Riflemans Killed'
						break;
					case 10:
						gg2i_strangeType = 'Quotes Killed'
						break;
					case 11:
						gg2i_strangeType = 'Sentries Destroyed'
						break;
					case 12:
						gg2i_strangeType = 'Invulns'
						break;
					case 13:
						gg2i_strangeType = 'Knife Kills'
						break;
				}
				
				gg2i_strangeCount = killedby.gg2i_strange_count[killedby.class] + killedby.gg2i_strange_count_got[killedby.class];
				if (gg2i_strangeCount > -1)
				{
					if (gg2i_strangeCount < 10)
						gg2i_strangeMessage[2] = 'Strange';
					else if (gg2i_strangeCount < 25)
						gg2i_strangeMessage[2] = 'Unremarkable';
					else if (gg2i_strangeCount < 45)
						gg2i_strangeMessage[2] = 'Scarcely Lethal';
					else if (gg2i_strangeCount < 70)
						gg2i_strangeMessage[2] = 'Mildly Menacing';
					else if (gg2i_strangeCount < 100)
						gg2i_strangeMessage[2] = 'Somewhat Threatening';
					else if (gg2i_strangeCount < 135)
						gg2i_strangeMessage[2] = 'Uncharitable';
					else if (gg2i_strangeCount < 175)
						gg2i_strangeMessage[2] = 'Notably Dangerous';
					else if (gg2i_strangeCount < 225)
						gg2i_strangeMessage[2] = 'Sufficiently Lethal';
					else if (gg2i_strangeCount < 275)
						gg2i_strangeMessage[2] = 'Truly Feared';
					else if (gg2i_strangeCount < 350)
						gg2i_strangeMessage[2] = 'Spectacularly Lethal';
					else if (gg2i_strangeCount < 500)
						gg2i_strangeMessage[2] = 'Gore-Spattered';
					else if (gg2i_strangeCount < 750)
						gg2i_strangeMessage[2] = 'Wicked Nasty';
					else if (gg2i_strangeCount < 999)
						gg2i_strangeMessage[2] = 'Positively Inhumane';
					else if (gg2i_strangeCount < 1000)
						gg2i_strangeMessage[2] = 'Totally Ordinary';
					else if (gg2i_strangeCount < 1500)
						gg2i_strangeMessage[2] = 'Face-Melting';
					else if (gg2i_strangeCount < 2500)
						gg2i_strangeMessage[2] = 'Rage-Inducing';
					else if (gg2i_strangeCount < 5000)
						gg2i_strangeMessage[2] = 'Server-Clearing';
					else if (gg2i_strangeCount < 7500)
						gg2i_strangeMessage[2] = 'Epic';
					else if (gg2i_strangeCount < 7617)
						gg2i_strangeMessage[2] = 'Legendary';
					else if (gg2i_strangeCount < 8500)
						gg2i_strangeMessage[2] = 'Australian';
					else
						gg2i_strangeMessage[2] = 'Hale' + gg2i.smallQuote + 's Own';
				}
				switch(killedby.class)
				{
					case CLASS_SCOUT:
						gg2i_strangeMessage[2] += ' Scattergun';
						break;
					case CLASS_PYRO:
						gg2i_strangeMessage[2] += ' Flamethrower';
						break;
					case CLASS_SOLDIER:
						gg2i_strangeMessage[2] += ' Rocketlauncher';
						break;
					case CLASS_HEAVY:
						gg2i_strangeMessage[2] += ' Minigun';
						break;
					case CLASS_DEMOMAN:
						gg2i_strangeMessage[2] += ' Minegun';
						break;
					case CLASS_MEDIC:
						gg2i_strangeMessage[2] += ' Medigun';
						break;
					case CLASS_ENGINEER:
						gg2i_strangeMessage[2] += ' Shotgun';
						break;
					case CLASS_SPY:
						gg2i_strangeMessage[2] += ' Revolver';
						break;
					case CLASS_SNIPER:
						gg2i_strangeMessage[2] += ' Rifle';
						break;
					case CLASS_QUOTE:
						gg2i_strangeMessage[2] += ' Blade';
						break;
				}
				gg2i_strangeMessage[2] += ' - ' + gg2i_strangeType + ' : ' + string(gg2i_strangeCount);
			}
		}
	");
	object_event_add(DeathCam, ev_draw, 0, "
		draw_set_halign(fa_right);
		draw_set_valign(fa_bottom);
		if (variable_local_exists('gg2i_titlemessage'))
		{
			if (gg2i_titlemessage != '')
			{
				draw_text_transformed(view_xview + view_wview[0] - 64, view_yview + 100, gg2i_titlemessage, 1, 1, 0);
				draw_sprite_ext(gg2i_titlesprite, 0, view_xview + view_wview[0] - 64, view_yview + 100 - 64, 1, 1, 0, c_white, 1);
			}
		}
		draw_set_halign(fa_left);
		draw_set_valign(fa_bottom);
		if (variable_local_exists('gg2i_strangeType'))
		{
			if (gg2i_strangeType != '')
			{
				draw_set_color(c_white);
				draw_text_transformed(view_xview, view_yview + 60, gg2i_strangeMessage[0], 1, 1, 0);
				draw_set_color(make_color_rgb(207, 106, 50));
				draw_text_transformed(view_xview, view_yview + 80, gg2i_strangeMessage[1], 1, 1, 0);
				draw_set_color(c_white);
				draw_text_transformed(view_xview, view_yview + 100, gg2i_strangeMessage[2], 1, 1, 0);
			}
		}
		draw_set_halign(fa_center);
		draw_set_valign(fa_center);
	");

	//Track strange count
	object_event_add(Character, ev_destroy, 0, "
		if (lastDamageDealer > 0 && lastDamageDealer != player)
		{
			_classExist = false;
			with (lastDamageDealer)
			{
				if (variable_local_exists('class'))
					other._classExist = true;
			}
			if (_classExist)
			{
				if (lastDamageDealer.gg2i_strange_type[lastDamageDealer.class] > -1)
				{
					switch(lastDamageDealer.gg2i_strange_type[lastDamageDealer.class])
					{
						case 0: //Kills
							lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 1: //Runner Kills
							if (player.class == CLASS_SCOUT)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 2: //Firebug Kills
							if (player.class == CLASS_PYRO)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 3: //Rocketman Kills
							if (player.class == CLASS_SOLDIER)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 4: //Overweight Kills
							if (player.class == CLASS_HEAVY)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 5: //Detonator Kills
							if (player.class == CLASS_DEMOMAN)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 6: //Healer Kills
							if (player.class == CLASS_MEDIC)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 7: //Constructor Kills
							if (player.class == CLASS_ENGINEER)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 8: //Infiltrator Kills
							if (player.class == CLASS_SPY)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 9: //Rifleman Kills
							if (player.class == CLASS_SNIPER)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 10: //Quote Kills
							if (player.class == CLASS_QUOTE)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
						case 13: //Knife Kills
							if (lastDamageSource == DAMAGE_SOURCE_KNIFE || lastDamageSource == DAMAGE_SOURCE_BACKSTAB)
								lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
							break;
					}
				}
			}
		}
	");
	object_event_add(Player, ev_step, ev_step_end, "
		if (!variable_local_exists('gg2i_invuln_old'))
			gg2i_invuln_old = 0;
		if (gg2i_strange_type[class] == 12)
		{
			if (stats[INVULNS] != gg2i_invuln_old)
			{
				gg2i_strange_count_got[class] += stats[INVULNS] - gg2i_invuln_old;
				gg2i_invuln_old = stats[INVULNS];
			}
		}
	");
	object_event_add(Sentry, ev_destroy, 0, "
		if(lastDamageDealer > 0 && lastDamageDealer != ownerPlayer)
		{
			_classExist = false;
			with (lastDamageDealer)
			{
				if (variable_local_exists('class'))
					other._classExist = true;
			}
			if (_classExist)
			{
				if (lastDamageDealer.gg2i_strange_type[lastDamageDealer.class] > -1)
				{
					if (lastDamageDealer.gg2i_strange_type[lastDamageDealer.class] == 11) //Sentry Kills
					{
						lastDamageDealer.gg2i_strange_count_got[lastDamageDealer.class] += 1;
					}
				}
			}
		}
	");
	object_event_add(WinBanner, ev_create, 0,"
		//If unique key exists
		if(variable_global_exists('unique_key'))
		{
			//exclude map types...
			if (string_copy(global.currentMap, 0, 2) != 'dj' and
				string_copy(global.currentMap, 0, 2) != 'rj' and
				string_copy(global.currentMap, 0, 2) != 'rr' and
				string_copy(global.currentMap, 0, 2) != 'qr' and
				string_copy(global.currentMap, 0, 4) != 'gg2w')
			{
				strange_total = 0;
				for (i = 0; i  < 10; i += 1)
				{
					strange_total += global.myself.gg2i_strange_count_got[i];
				}
				if (strange_total > 0)
				{
					//Access to update server
					strange_buffer = buffer_create();
					write_string(strange_buffer, 'user_key=' + global.unique_key);
					gg2i_strangeString = '';
					if (global.myself.stats[INVULNS] != global.myself.gg2i_invuln_old)
					{
						global.myself.gg2i_strange_count_got[class] += global.myself.stats[INVULNS] - global.myself.gg2i_invuln_old;
						global.myself.gg2i_invuln_old = global.myself.stats[INVULNS];
					}
					for (i = 0; i  < 10; i += 1)
					{
						gg2i_strangeString += string(global.myself.gg2i_strange_count_got[i]);
						if (i != 9)
						{
							gg2i_strangeString += ',';
						}
					}
					write_string(strange_buffer, '&strange_count=' + gg2i_strangeString);
					gg2iHttpHandler.http_buffer = strange_buffer;
					ds_queue_enqueue(gg2iHttpHandler.request_queue, 3);
					ds_queue_enqueue(gg2iHttpHandler.player_queue, global.myself);
				}
				//reset values
				for (i = 0; i  < 10; i += 1)
				{
					global.myself.gg2i_strange_count_got[i] = 0;
				}
				global.myself.gg2i_invuln_old = 0;
			}
		}
	");

}